> For the complete documentation index, see [llms.txt](https://docs.sonoransoftware.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sonoransoftware.com/cad/api-integration/websocket-api/authentication.md).

# Authentication

## Websocket Authentication

### Authentication Method

#### **Method:**

```
authenticatev2
```

#### **Parameters:**

| Parameter     | Type              |
| ------------- | ----------------- |
| `communityId` | String            |
| `apiKey`      | String            |
| `serverId`    | Number (Optional) |

### Response

```
{ success: boolean, error: string, count: number }
```

### serverId

`serverId` is optional for websocket authentication.

Use it when you want this websocket connection to receive Sonoran CAD push events for a specific configured server. If provided, the `serverId` must match a valid server configured in your CAD.

If `serverId` is omitted, the websocket session can still call websocket API methods such as `unitLocation`, but it will not be used as a push event destination for a specific server.

### Auth JS example (Node.js) Requires:

**Add the Microsoft SignalR Library**

```
npm i @microsoft/signalr
```

<pre class="language-js"><code class="lang-js"><strong>// Import the signalr library for backend connection
</strong><strong>const signalR = require("@microsoft/signalr");
</strong>
// Establist the connection object
const connection = new signalR.HubConnectionBuilder()
  .withUrl("https://api.sonorancad.com/apiWsHub", {
    transport: signalR.HttpTransportType.WebSockets,
    skipNegotiation: true,
  })
  .withAutomaticReconnect()
  .build();

// Start the WSS connection
await connection.start();

// Replace community ID and API key
const auth = await connection.invoke("authenticatev2", "yourCommunityId", "yourApiKey", 1);
if (!auth?.success) {
  throw new Error(`Authentication failed: ${auth?.error || "unknown error"}`);
}
</code></pre>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sonoransoftware.com/cad/api-integration/websocket-api/authentication.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
